  {C, D, E, F, G, A, H, C  D  E  F  G  A  H  c  d  e  f  g  a  h  c' d' e' f' g' a' h'}
  { 2  4  6  7  9 11 13 14 16 18 19 21 23 25 26 28 30 31 33 35 37 38 40 42 43 45 47 49}

  {C,# D,# F,# G,# A,# C#  D#  F#  G#  A#  c#  d#  f#  g#  a#  c'# d'# f'# g'# a'#}
  {Db, Eb, Gb, Ab, Hb, Db  Eb  Gb  Ab  Hb  db  eb  gb  ab  hb  d'b e'b g'b a'b h'b}
  { 3   5   8  10  12  15  17  20  22  24  27  29  32  34  36  39  41  44  46  48 }

  { r   R (rest)}
  {200 200}

  {priklad: G,#4. d'b1 R2.}

    const basiclen=8;       {trvanie celej noty v 1/18.2 sekundy}

    var musicerror:byte;

{    procedure PlayMusic(mel:string; var from:byte);
       zahra notu na pozici from v retazci mel, kod chyby je v sounderror:
       0 - OK
       1 - nedokonceny zapis noty
       2 - neznamy znak
       3 - nespravny zapis noty (zle poradie symbolov, dvakrat ., atd)}


    const freq:array[2..49] of word=(
      131,  139,  147,  156,  165,  175,  185,  196,  208,  220,  233,  247,
      262,  277,  294,  311,  330,  349,  370,  392,  415,  440,  466,  494,
      523,  554,  587,  622,  659,  698,  740,  784,  831,  880,  932,  988,
     1047, 1109, 1175, 1245, 1319, 1397, 1480, 1568, 1661, 1760, 1865, 1976);

    type element=set of (_note,_oct,_half,_len,_dot);


    procedure PlayMusic(mel:string; var from:byte);
      var note,notelen:byte;
          flags:element;

      procedure SetNote(n:byte);
        begin
          if _note in flags then musicerror:=3
          else
            begin note:=n; flags:=flags+[_note]; end;
        end;

      procedure SetOct(o:char);
        begin
          if not (_note in flags) or (_oct in flags) then musicerror:=3
          else
            begin
              if o=',' then Dec(note,12)
              else Inc(note,12);
              flags:=flags+[_oct];
            end;
        end;

      procedure SetHalf(h:char);
        begin
          if not (_note in flags) or (_half in flags) then musicerror:=3
          else
            begin
              if h='b' then Dec(note)
              else Inc(note);
              flags:=flags+[_half];
            end;
        end;

      procedure SetLen(l:byte);
        begin
          if _len in flags then musicerror:=3
          else
            begin notelen:=basiclen div l; flags:=flags+[_len]; end;
        end;

      procedure SetDot;
        begin
          if not (_len in flags) or (_dot in flags) then musicerror:=3
          else
            begin notelen:=notelen*3 div 2; flags:=flags+[_dot]; end;
        end;

      begin
        flags:=[];

        while (from<=Length(mel)) and (mel[from]<>' ') do
          begin
            case mel[from] of
              'C': SetNote(14);
              'D': SetNote(16);
              'E': SetNote(18);
              'F': SetNote(19);
              'G': SetNote(21);
              'A': SetNote(23);
              'H': SetNote(25);
              'c': SetNote(26);
              'd': SetNote(28);
              'e': SetNote(30);
              'f': SetNote(31);
              'g': SetNote(33);
              'a': SetNote(35);
              'h': SetNote(37);
              'r','R':SetNote(200);
              ',': SetOct(',');
              '''':SetOct('''');
              '#': SetHalf('#');
              'b': SetHalf('b');
              '1': SetLen(1);
              '2': SetLen(2);
              '4': SetLen(4);
              '8': SetLen(8);
              '.': SetDot;
              else note:=0;
            end;
            Inc(from);
        end;

        if note=0 then
          begin musicerror:=2; Exit; end;

        if not((_note in flags) and (_len in flags)) then
          begin musicerror:=1; Exit; end;

        if musicerror=3 then Exit;

        _music:=notelen;
        if note>49 then NoSound
        else if soundswitch then
          begin NoSound; Delay(10); Sound(freq[note]); end;

        Inc(from); if from>Length(mel) then from:=1;
        musicerror:=0;
      end;
