
  var names:array[1..5] of string;
      times:array[1..5] of longint;

  procedure WriteScoreTable;
    {zakoduje a zapise tabulku na zaciatok sprites.csp}
    var f:file;
        code:byte;
        i,j:integer;
    begin
      code:=0;
      for i:=1 to 5 do
        begin
          for j:=1 to 8 do code:=code xor Ord(names[i,j]);
          asm
            mov   si,offset times
            mov   bx,i
            dec   bx
            shl   bx,2

            mov   al,[code]
            xor   al,[bx+si]
            xor   al,[bx+si+1]
            xor   al,[bx+si+2]
            xor   al,[bx+si+3]
            mov   [code],al
          end;
        end;

      for i:=1 to 5 do
        begin
          for j:=1 to 8 do
            names[i,j]:=Char(Ord(names[i,j]) xor code xor 17*i xor 13*j);
          asm
            mov   si,offset times
            mov   bx,i
            dec   bx
            shl   bx,2

            mov   al,byte ptr[i]
            mov   ch,17
            mul   ch
            mov   ch,al

            mov   cl,13
            shl   cl,3
            add   cl,13

            mov   al,[code]

            xor   [bx+si],al
            xor   [bx+si],ch
            xor   [bx+si],cl
            add   cl,13
            xor   [bx+si+1],al
            xor   [bx+si+1],ch
            xor   [bx+si+1],cl
            add   cl,13
            xor   [bx+si+2],al
            xor   [bx+si+2],ch
            xor   [bx+si+2],cl
            add   cl,13
            xor   [bx+si+3],al
            xor   [bx+si+3],ch
            xor   [bx+si+3],cl
          end;
        end;

      Assign(f,'sprites.csp'); Reset(f,1);
      for i:=1 to 5 do
        begin
          for j:=1 to 8 do BlockWrite(f,names[i,j],1);
          BlockWrite(f,times[i],4);
        end;
      BlockWrite(f,code,1);
      Close(f);
    end;


  procedure ReadScoreTable;
    {nacita a dekoduje tabulku do names[] a times[]}
    var f:file;
        code,code2:byte;
        i,j:integer;
    begin
      Assign(f,'sprites.csp'); Reset(f,1);
      for i:=1 to 5 do
        begin
          for j:=1 to 8 do BlockRead(f,names[i,j],1);
          names[i,0]:=#8;
          BlockRead(f,times[i],4);
        end;
      BlockRead(f,code2,1);
      Close(f);

      code:=0;
      for i:=1 to 5 do
        begin
          for j:=1 to 8 do
            begin
              names[i,j]:=Char(Ord(names[i,j]) xor 13*j xor 17*i);
              code:=code xor Ord(names[i,j]);
            end;
          asm
            mov   si,offset times
            mov   bx,i
            dec   bx
            shl   bx,2

            mov   al,byte ptr[i]
            mov   ch,17
            mul   ch
            mov   ch,al

            mov   cl,13
            shl   cl,3
            add   cl,13

            mov   al,[code]

            xor   [bx+si],cl
            xor   [bx+si],ch
            xor   al,[bx+si]
            add   cl,13
            xor   [bx+si+1],cl
            xor   [bx+si+1],ch
            xor   al,[bx+si+1]
            add   cl,13
            xor   [bx+si+2],cl
            xor   [bx+si+2],ch
            xor   al,[bx+si+2]
            add   cl,13
            xor   [bx+si+3],cl
            xor   [bx+si+3],ch
            xor   al,[bx+si+3]

            mov   [code],al
          end;
        end;

      if code=code2 then
        for i:=1 to 5 do
          begin
            for j:=1 to 8 do names[i,j]:=Char(Ord(names[i,j]) xor code);
            asm
              mov   si,offset times
              mov   bx,i
              dec   bx
              shl   bx,2

              mov   al,[code]
              xor   [bx+si],al
              xor   [bx+si+1],al
              xor   [bx+si+2],al
              xor   [bx+si+3],al
            end;
          end
      else
        for i:=1 to 5 do
          begin names[i]:='.NOBODY.'; times[i]:=maxlongint; end;
    end;
